=== modified file 'init/parse_job.c'
--- init/parse_job.c	2009-01-29 04:23:21 +0000
+++ init/parse_job.c	2009-02-23 08:09:53 +0000
@@ -283,18 +2592,38 @@
 	   size_t     *pos,
 	   size_t     *lineno)
 {
+	nih_local void *tmp_parent;
  	JobClass *class;
+	const char *file_start = file;
+	int retval;
 
 	nih_assert (name != NULL);
 	nih_assert (file != NULL);
 	nih_assert (pos != NULL);
 
+	//yydebug = 1;
+
+	tmp_parent = nih_alloc (NULL, 1);
+	if (! tmp_parent)
+		nih_return_system_error (NULL);
+
 	class = job_class_new (parent, name);
 	if (! class)
 		nih_return_system_error (NULL);
 
-	if (nih_config_parse_file (file, len, pos, lineno,
-				   stanzas, class) < 0) {
+	retval = yyparse (class, &file, tmp_parent, lineno);
+	*pos = file - file_start;
+
+	if (retval) {
+		nih_free (class);
+		if (retval == 2)
+			nih_return_no_memory_error (NULL);
+		return NULL;
+	}
+
+	if (! job_class_is_valid (class)) {
+		nih_error_raise (NIH_CONFIG_INVALID_VALUE,
+				 _(NIH_CONFIG_INVALID_VALUE_STR));
 		nih_free (class);
 		return NULL;
 	}
